Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoTimesExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoTimesExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoTimesExpressions.cs	(revision 15017)
@@ -1,41 +1,8 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
   using System;
-
-  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
-
-  [Serializable]
-  [StorableClass]
-  public abstract class DoTimesExpression : LoopExpression {
-    protected DoTimesExpression() { }
-    protected DoTimesExpression(LoopState state) : base(state) { }
-    [StorableConstructor]
-    protected DoTimesExpression(bool deserializing) : base(deserializing) { }
-
-    protected override bool HasInsufficientArguments(IInternalPushInterpreter interpreter, IPushStack<Expression> sourceStack) {
-      return (interpreter.IntegerStack.Count < 1) || (sourceStack.Count == 0) || (interpreter.IntegerStack.Top <= 0);
-    }
-
-    protected override LoopState InitState(IInternalPushInterpreter interpreter, IPushStack<Expression> sourceStack) {
-      return LoopState.Create(interpreter.PoolContainer.LoopStatePool,
-        body: sourceStack.Pop(),
-        currentIndex: 1,
-        destinationIndex: interpreter.IntegerStack.Pop(),
-        incrementor: 1);
-    }
-
-    protected override void PushIteration(IInternalPushInterpreter interpreter) {
-      var newState = LoopState.Create(interpreter.PoolContainer.LoopStatePool, State.Body, State.CurrentIndex + State.Incrementor, State.DestinationIndex, State.Incrementor);
-      var nextLoopExpression = Clone(newState, interpreter);
-
-      interpreter.ExecStack.Push(nextLoopExpression, State.Body);
-    }
-
-    protected override void PushLastIteration(IInternalPushInterpreter interpreter) {
-      interpreter.ExecStack.Push(State.Body);
-    }
-  }
+  using Attributes;
+  using Interpreter;
+  using Persistence.Default.CompositeSerializers.Storable;
+  using Stack;
 
   /// <summary>
@@ -48,22 +15,46 @@
   [StorableClass]
   [PushExpression(StackTypes.Code, "CODE.DO*TIMES", StackTypes.Integer)]
-  public class CodeDoTimesExpression : DoTimesExpression {
+  public class CodeDoTimesExpression : StatelessExpression {
     public CodeDoTimesExpression() { }
-    public CodeDoTimesExpression(LoopState state) : base(state) { }
     [StorableConstructor]
     protected CodeDoTimesExpression(bool deserializing) : base(deserializing) { }
 
     public override void Eval(IInternalPushInterpreter interpreter) {
-      Eval(interpreter, interpreter.CodeStack);
-    }
-    public override bool IsNoop(IInternalPushInterpreter interpreter) {
-      return State.Body == null && HasInsufficientArguments(interpreter, interpreter.CodeStack);
+      var destinationIndex = Math.Max(0, interpreter.IntegerStack.Top - 1);
+
+      if (destinationIndex == 0) {
+        interpreter.IntegerStack.Pop();
+        interpreter.ExecStack.Push((PushProgram)interpreter.CodeStack.Pop());
+        return;
+      }
+
+      interpreter.IntegerStack.Top = 0;
+      interpreter.IntegerStack.Push(destinationIndex);
+
+      var popExpressions = ExpressionTable.GetStatelessExpression<IntegerPopExpression>();
+      PushProgram program;
+
+      if (!interpreter.CodeStack.Top.IsProgram) {
+        var expressions = interpreter.PoolContainer.ExpressionListPool.Get();
+        expressions.Add(interpreter.ExecStack.Top);
+        expressions.Add(popExpressions);
+
+        program = PushProgram.Create(interpreter.PoolContainer.PushProgramPool, expressions);
+      } else {
+        program = PushProgram.Merge(
+          interpreter.PoolContainer.PushProgramPool,
+          interpreter.PoolContainer.ExpressionListPool,
+          (PushProgram)interpreter.CodeStack.Top,
+          popExpressions);
+      }
+
+      interpreter.CodeStack.Top = program;
+      interpreter.ExecStack.Push(ExpressionTable.GetStatelessExpression<CodeDoRangeExpression>());
     }
 
-    protected override LoopExpression Clone(LoopState state, IInternalPushInterpreter interpreter) {
-      var expression = interpreter.PoolContainer.GetStatefulExpression<CodeDoTimesExpression>();
-      expression.State = state;
-
-      return expression;
+    public override bool IsNoop(IInternalPushInterpreter interpreter) {
+      return interpreter.IntegerStack.IsEmpty ||
+             interpreter.IntegerStack.Top < 0 ||
+             interpreter.CodeStack.IsEmpty;
     }
   }
@@ -80,24 +71,46 @@
   [Serializable]
   [StorableClass]
-  [PushExpression(StackTypes.Exec, "EXEC.DO*TIMES", StackTypes.Integer)]
-  public class ExecDoTimesExpression : DoTimesExpression {
+  [PushExpression(StackTypes.Exec, "EXEC.DO*TIMES", StackTypes.Integer, execIn: 1)]
+  public class ExecDoTimesExpression : StatelessExpression {
     public ExecDoTimesExpression() { }
-    public ExecDoTimesExpression(LoopState state) : base(state) { }
     [StorableConstructor]
     protected ExecDoTimesExpression(bool deserializing) : base(deserializing) { }
 
     public override void Eval(IInternalPushInterpreter interpreter) {
-      Eval(interpreter, interpreter.ExecStack);
+      var destinationIndex = Math.Max(0, interpreter.IntegerStack.Top - 1);
+
+      if (destinationIndex == 0) {
+        interpreter.IntegerStack.Pop();
+        return;
+      }
+
+      interpreter.IntegerStack.Top = 0;
+      interpreter.IntegerStack.Push(destinationIndex);
+
+      var popExpressions = ExpressionTable.GetStatelessExpression<IntegerPopExpression>();
+      PushProgram program;
+
+      if (!interpreter.ExecStack.Top.IsProgram) {
+        var expressions = interpreter.PoolContainer.ExpressionListPool.Get();
+        expressions.Add(interpreter.ExecStack.Top);
+        expressions.Add(popExpressions);
+
+        program = PushProgram.Create(interpreter.PoolContainer.PushProgramPool, expressions);
+      } else {
+        program = PushProgram.Merge(
+          interpreter.PoolContainer.PushProgramPool,
+          interpreter.PoolContainer.ExpressionListPool,
+          (PushProgram)interpreter.ExecStack.Top,
+          popExpressions);
+      }
+
+      interpreter.ExecStack.Top = program;
+      interpreter.ExecStack.Push(ExpressionTable.GetStatelessExpression<ExecDoRangeExpression>());
     }
 
     public override bool IsNoop(IInternalPushInterpreter interpreter) {
-      return State.Body == null && HasInsufficientArguments(interpreter, interpreter.ExecStack);
-    }
-
-    protected override LoopExpression Clone(LoopState state, IInternalPushInterpreter interpreter) {
-      var expression = interpreter.PoolContainer.GetStatefulExpression<ExecDoTimesExpression>();
-      expression.State = state;
-
-      return expression;
+      return interpreter.IntegerStack.IsEmpty ||
+             interpreter.IntegerStack.Top < 0 ||
+             interpreter.ExecStack.IsEmpty;
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DuplicateExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DuplicateExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DuplicateExpressions.cs	(revision 15017)
@@ -88,5 +88,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Exec, "EXEC.DUP")]
+  [PushExpression(StackTypes.Exec, "EXEC.DUP", execIn: 1)]
   public class ExecDuplicateExpression : DuplicateExpression<Expression> {
     public ExecDuplicateExpression() { }
@@ -120,6 +120,38 @@
 
   [StorableClass]
+  [PushExpression(StackTypes.Char, "CHAR.DUP")]
+  public class CharDuplicateExpression : DuplicateExpression<char> {
+    public CharDuplicateExpression() { }
+    [StorableConstructor]
+    protected CharDuplicateExpression(bool deserializing) : base(deserializing) { }
+
+    public override bool IsNoop(IInternalPushInterpreter interpreter) {
+      return interpreter.CharStack.IsEmpty;
+    }
+
+    public override void Eval(IInternalPushInterpreter interpreter) {
+      Eval(interpreter.CharStack);
+    }
+  }
+
+  [StorableClass]
+  [PushExpression(StackTypes.String, "STRING.DUP")]
+  public class StringDuplicateExpression : DuplicateExpression<string> {
+    public StringDuplicateExpression() { }
+    [StorableConstructor]
+    protected StringDuplicateExpression(bool deserializing) : base(deserializing) { }
+
+    public override bool IsNoop(IInternalPushInterpreter interpreter) {
+      return interpreter.StringStack.IsEmpty;
+    }
+
+    public override void Eval(IInternalPushInterpreter interpreter) {
+      Eval(interpreter.StringStack);
+    }
+  }
+
+  [StorableClass]
   [PushExpression(StackTypes.IntegerVector, "INTEGER[].DUP")]
-  public class IntegerVectorDuplicateExpression : DuplicateExpression<List<long>> {
+  public class IntegerVectorDuplicateExpression : DuplicateExpression<IReadOnlyList<long>> {
     public IntegerVectorDuplicateExpression() { }
     [StorableConstructor]
@@ -137,5 +169,5 @@
   [StorableClass]
   [PushExpression(StackTypes.FloatVector, "FLOAT[].DUP")]
-  public class FloatVectorDuplicateExpression : DuplicateExpression<List<double>> {
+  public class FloatVectorDuplicateExpression : DuplicateExpression<IReadOnlyList<double>> {
     public FloatVectorDuplicateExpression() { }
     [StorableConstructor]
@@ -153,5 +185,5 @@
   [StorableClass]
   [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].DUP")]
-  public class BooleanVectorDuplicateExpression : DuplicateExpression<List<bool>> {
+  public class BooleanVectorDuplicateExpression : DuplicateExpression<IReadOnlyList<bool>> {
     public BooleanVectorDuplicateExpression() { }
     [StorableConstructor]
@@ -169,5 +201,5 @@
   [StorableClass]
   [PushExpression(StackTypes.StringVector, "STRING[].DUP")]
-  public class StringVectorDuplicateExpression : DuplicateExpression<List<string>> {
+  public class StringVectorDuplicateExpression : DuplicateExpression<IReadOnlyList<string>> {
     public StringVectorDuplicateExpression() { }
     [StorableConstructor]
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EmptyExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EmptyExpression.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EmptyExpression.cs	(revision 15017)
@@ -101,5 +101,5 @@
 
   [PushExpression(StackTypes.IntegerVector, "INTEGER[].EMPTY", StackTypes.Boolean)]
-  public class IntegerVectorEmptyExpression : EmptyExpression<List<long>> {
+  public class IntegerVectorEmptyExpression : EmptyExpression<IReadOnlyList<long>> {
     public IntegerVectorEmptyExpression() { }
     [StorableConstructor]
@@ -111,5 +111,5 @@
 
   [PushExpression(StackTypes.FloatVector, "FLOAT[].EMPTY", StackTypes.Boolean)]
-  public class FloatVectorEmptyExpression : EmptyExpression<List<double>> {
+  public class FloatVectorEmptyExpression : EmptyExpression<IReadOnlyList<double>> {
     public FloatVectorEmptyExpression() { }
     [StorableConstructor]
@@ -121,5 +121,5 @@
 
   [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].EMPTY", StackTypes.Boolean)]
-  public class BooleanVectorEmptyExpression : EmptyExpression<List<bool>> {
+  public class BooleanVectorEmptyExpression : EmptyExpression<IReadOnlyList<bool>> {
     public BooleanVectorEmptyExpression() { }
     [StorableConstructor]
@@ -131,5 +131,5 @@
 
   [PushExpression(StackTypes.StringVector, "STRING[].EMPTY", StackTypes.Boolean)]
-  public class StringVectorEmptyExpression : EmptyExpression<List<string>> {
+  public class StringVectorEmptyExpression : EmptyExpression<IReadOnlyList<string>> {
     public StringVectorEmptyExpression() { }
     [StorableConstructor]
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EqualsExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EqualsExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EqualsExpressions.cs	(revision 15017)
@@ -1,4 +1,6 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
   using System.Collections.Generic;
+  using System.Linq;
+
   using Attributes;
 
@@ -23,5 +25,15 @@
       stack.Remove(2);
 
-      booleanStack.Push(first.Equals(second));
+      var equal = first.Equals(second);
+      booleanStack.Push(equal);
+    }
+
+    protected void Eval(IPushStack<IReadOnlyList<T>> vectorStack, IPushStack<bool> booleanStack) {
+      var first = vectorStack[1];
+      var second = vectorStack[0];
+      vectorStack.Remove(2);
+
+      var equal = first.SequenceEqual(second);
+      booleanStack.Push(equal);
     }
   }
@@ -92,5 +104,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Exec, "EXEC.=", StackTypes.Boolean)]
+  [PushExpression(StackTypes.Exec, "EXEC.=", StackTypes.Boolean, execIn: 0)]
   public class ExecEqualsExpression : EqualsExpression<Expression> {
     public ExecEqualsExpression() { }
@@ -157,5 +169,5 @@
   [StorableClass]
   [PushExpression(StackTypes.IntegerVector, "INTEGER[].=", StackTypes.Boolean)]
-  public class IntegerVectorEqualsExpression : EqualsExpression<List<long>> {
+  public class IntegerVectorEqualsExpression : EqualsExpression<long> {
     public IntegerVectorEqualsExpression() { }
     [StorableConstructor]
@@ -173,5 +185,5 @@
   [StorableClass]
   [PushExpression(StackTypes.FloatVector, "FLOAT[].=", StackTypes.Boolean)]
-  public class FloatVectorEqualsExpression : EqualsExpression<List<double>> {
+  public class FloatVectorEqualsExpression : EqualsExpression<double> {
     public FloatVectorEqualsExpression() { }
     [StorableConstructor]
@@ -189,5 +201,5 @@
   [StorableClass]
   [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].=", StackTypes.Boolean)]
-  public class BooleanVectorEqualsExpression : EqualsExpression<List<bool>> {
+  public class BooleanVectorEqualsExpression : EqualsExpression<bool> {
     public BooleanVectorEqualsExpression() { }
     [StorableConstructor]
@@ -205,5 +217,5 @@
   [StorableClass]
   [PushExpression(StackTypes.StringVector, "STRING[].=", StackTypes.Boolean)]
-  public class StringVectorEqualsExpression : EqualsExpression<List<string>> {
+  public class StringVectorEqualsExpression : EqualsExpression<string> {
     public StringVectorEqualsExpression() { }
     [StorableConstructor]
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExecExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExecExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExecExpressions.cs	(revision 15017)
@@ -1,3 +1,5 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
+  using System;
+
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
   using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
@@ -13,5 +15,5 @@
   /// </summary>
   [StorableClass]
-  [PushExpression(StackTypes.Exec, "EXEC.IF", StackTypes.Boolean)]
+  [PushExpression(StackTypes.Exec, "EXEC.IF", StackTypes.Boolean, execIn: 2)]
   public class ExecIfExpression : StatelessExpression {
     public ExecIfExpression() { }
@@ -35,5 +37,5 @@
   ///     "( EXEC.Y <TopItem> )".
   /// </summary>
-  [PushExpression(StackTypes.Exec, "EXEC.Y")]
+  [PushExpression(StackTypes.Exec, "EXEC.Y", execIn: 1)]
   [StorableClass]
   public class ExecYExpression : StatelessExpression {
@@ -58,5 +60,5 @@
       var result = PushProgram.Create(interpreter.PoolContainer.PushProgramPool, expressions);
 
-      interpreter.ExecStack.SetTop(result);
+      interpreter.ExecStack.Top = result;
       interpreter.ExecStack.Add(top);
     }
@@ -66,5 +68,5 @@
   ///     Removes the second item on the EXEC stack.
   /// </summary>
-  [PushExpression(StackTypes.Exec, "EXEC.K")]
+  [PushExpression(StackTypes.Exec, "EXEC.K", execIn: 2)]
   [StorableClass]
   public class ExecKExpression : StatelessExpression {
@@ -79,5 +81,5 @@
     public override void Eval(IInternalPushInterpreter interpreter) {
       var top = interpreter.ExecStack.Pop();
-      interpreter.ExecStack.SetTop(top);
+      interpreter.ExecStack.Top = top;
     }
   }
@@ -88,5 +90,5 @@
   ///     another instance of C, followed by another instance of A.
   /// </summary>
-  [PushExpression(StackTypes.Exec, "EXEC.S")]
+  [PushExpression(StackTypes.Exec, "EXEC.S", execIn: 3)]
   [StorableClass]
   public class ExecSExpression : StatelessExpression {
@@ -113,5 +115,5 @@
       var newTop = PushProgram.Create(interpreter.PoolContainer.PushProgramPool, expressions);
 
-      interpreter.ExecStack.SetTop(newTop);
+      interpreter.ExecStack.Top = newTop;
       interpreter.ExecStack.Push(c, a);
     }
@@ -121,6 +123,8 @@
   ///     Does nothing.
   /// </summary>
+  ///
+  [StorableClass]
+  [Serializable]
   [PushExpression(StackTypes.Exec, "EXEC.NOOP")]
-  [StorableClass]
   public class ExecNoopExpression : StatelessExpression {
     public ExecNoopExpression() { }
@@ -137,5 +141,5 @@
   }
 
-  [PushExpression(StackTypes.Exec, "EXEC.WHILE", StackTypes.Boolean)]
+  [PushExpression(StackTypes.Exec, "EXEC.WHILE", StackTypes.Boolean, execIn: 1)]
   [StorableClass]
   public class ExecWhileExpression : StatelessExpression {
@@ -165,5 +169,5 @@
   }
 
-  [PushExpression(StackTypes.Exec, "EXEC.DO*WHILE")]
+  [PushExpression(StackTypes.Exec, "EXEC.DO*WHILE", execIn: 1)]
   [StorableClass]
   public class ExecDoWhileExpression : StatelessExpression {
@@ -181,5 +185,5 @@
   }
 
-  [PushExpression(StackTypes.Exec, "EXEC.WHEN", StackTypes.Boolean)]
+  [PushExpression(StackTypes.Exec, "EXEC.WHEN", StackTypes.Boolean, execIn: 1)]
   [StorableClass]
   public class ExecWhenExpression : StatelessExpression {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/Expression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/Expression.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/Expression.cs	(revision 15017)
@@ -22,10 +22,7 @@
     public static readonly IReadOnlyCollection<Expression> EmptyContainer = new Expression[0];
 
-    public virtual string StringRepresentation
+    public abstract string StringRepresentation
     {
-      get
-      {
-        return ExpressionTable.TypeToAttributeTable[GetType()].ExpressionName;
-      }
+      get;
     }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExpressionTable.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExpressionTable.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExpressionTable.cs	(revision 15017)
@@ -33,4 +33,5 @@
       ExpressionNames = StatelessExpressionTable.Keys
         .Concat(StatefulExpressionFactory.Keys)
+        .Where(t => typeToNameTable.ContainsKey(t))
         .Select(type => typeToNameTable[type])
         .ToArray();
@@ -55,4 +56,8 @@
         typeToAttributeTable.Add(type, attribute);
         dictionary.Add(type, expression);
+
+        // do not index hidden expressions like push expression in tables
+        if (attribute.IsHidden) continue;
+
         indexToNameTable.Add(indexToNameTable.Keys.Count, attribute.ExpressionName);
         typeToNameTable.Add(type, attribute.ExpressionName);
@@ -89,4 +94,8 @@
         typeToAttributeTable.Add(type, attribute);
         dictionary.Add(type, creator);
+
+        // do not index hidden expressions like push expression in tables
+        if (attribute.IsHidden) continue;
+
         indexToNameTable.Add(indexToNameTable.Keys.Count, attribute.ExpressionName);
         typeToNameTable.Add(type, attribute.ExpressionName);
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FloatExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FloatExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FloatExpressions.cs	(revision 15017)
@@ -1,4 +1,6 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
   using System;
+  using System.Globalization;
+
   using Common;
 
@@ -30,5 +32,5 @@
       if (double.IsNegativeInfinity(result)) result = double.MinValue;
 
-      interpreter.FloatStack.SetTop(result);
+      interpreter.FloatStack.Top = result;
     }
   }
@@ -56,5 +58,5 @@
       if (double.IsNegativeInfinity(result)) result = double.MinValue;
 
-      interpreter.FloatStack.SetTop(result);
+      interpreter.FloatStack.Top = result;
     }
   }
@@ -82,5 +84,5 @@
       if (double.IsNegativeInfinity(result)) result = double.MinValue;
 
-      interpreter.FloatStack.SetTop(result);
+      interpreter.FloatStack.Top = result;
     }
   }
@@ -109,5 +111,5 @@
       if (double.IsNegativeInfinity(result)) result = double.MinValue;
 
-      interpreter.FloatStack.SetTop(result);
+      interpreter.FloatStack.Top = result;
     }
   }
@@ -136,5 +138,5 @@
       var result = second % first;
 
-      interpreter.FloatStack.SetTop(result);
+      interpreter.FloatStack.Top = result;
     }
   }
@@ -159,5 +161,5 @@
       var result = Math.Min(second, first);
 
-      interpreter.FloatStack.SetTop(result);
+      interpreter.FloatStack.Top = result;
     }
   }
@@ -182,5 +184,5 @@
       var result = Math.Max(second, first);
 
-      interpreter.FloatStack.SetTop(result);
+      interpreter.FloatStack.Top = result;
     }
   }
@@ -298,5 +300,5 @@
     public override void Eval(IInternalPushInterpreter interpreter) {
       var result = Math.Sin(interpreter.FloatStack.Top);
-      interpreter.FloatStack.SetTop(result);
+      interpreter.FloatStack.Top = result;
     }
   }
@@ -317,5 +319,5 @@
     public override void Eval(IInternalPushInterpreter interpreter) {
       var result = Math.Cos(interpreter.FloatStack.Top);
-      interpreter.FloatStack.SetTop(result);
+      interpreter.FloatStack.Top = result;
     }
   }
@@ -362,3 +364,86 @@
     }
   }
+
+  /// <summary>
+  ///     Pushes the result of truncating the top CHAR.
+  /// </summary>
+  [PushExpression(StackTypes.Float, "FLOAT.FROMCHAR", StackTypes.Char)]
+  [StorableClass]
+  public class FloatFromCharExpression : StatelessExpression {
+    public FloatFromCharExpression() { }
+    [StorableConstructor]
+    protected FloatFromCharExpression(bool deserializing) : base(deserializing) { }
+
+    public override bool IsNoop(IInternalPushInterpreter interpreter) {
+      return interpreter.CharStack.IsEmpty;
+    }
+
+    public override void Eval(IInternalPushInterpreter interpreter) {
+      var value = interpreter.CharStack.Pop();
+      interpreter.FloatStack.Push(value);
+    }
+  }
+
+  /// <summary>
+  ///     Pushes the result of parsing the top STRING.
+  /// </summary>
+  [PushExpression(StackTypes.Float, "FLOAT.FROMSTRING", StackTypes.String)]
+  [StorableClass]
+  public class FloatFromStringExpression : StatelessExpression {
+    public FloatFromStringExpression() { }
+    [StorableConstructor]
+    protected FloatFromStringExpression(bool deserializing) : base(deserializing) { }
+
+    public override bool IsNoop(IInternalPushInterpreter interpreter) {
+      double tmp;
+      return interpreter.StringStack.IsEmpty ||
+             interpreter.StringStack.Top.Length == 0 ||
+             !double.TryParse(interpreter.StringStack.Top, out tmp);
+    }
+
+    public override void Eval(IInternalPushInterpreter interpreter) {
+      var str = interpreter.StringStack.Pop();
+      var value = double.Parse(str, CultureInfo.InvariantCulture);
+
+      interpreter.FloatStack.Push(value);
+    }
+  }
+
+  /// <summary>
+  ///     Pushes the result of increasing the top INTEGER by 1.
+  /// </summary>
+  [PushExpression(StackTypes.Float, "FLOAT.INC")]
+  [StorableClass]
+  public class FloatIncExpression : StatelessExpression {
+    public FloatIncExpression() { }
+    [StorableConstructor]
+    protected FloatIncExpression(bool deserializing) : base(deserializing) { }
+
+    public override bool IsNoop(IInternalPushInterpreter interpreter) {
+      return interpreter.FloatStack.IsEmpty;
+    }
+
+    public override void Eval(IInternalPushInterpreter interpreter) {
+      interpreter.FloatStack.Top += 1;
+    }
+  }
+
+  /// <summary>
+  ///     Pushes the result of decreasing the top INTEGER by 1.
+  /// </summary>
+  [PushExpression(StackTypes.Float, "FLOAT.DEC")]
+  [StorableClass]
+  public class FloatDecExpression : StatelessExpression {
+    public FloatDecExpression() { }
+    [StorableConstructor]
+    protected FloatDecExpression(bool deserializing) : base(deserializing) { }
+
+    public override bool IsNoop(IInternalPushInterpreter interpreter) {
+      return interpreter.FloatStack.IsEmpty;
+    }
+
+    public override void Eval(IInternalPushInterpreter interpreter) {
+      interpreter.FloatStack.Top -= 1;
+    }
+  }
 }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FlushExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FlushExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FlushExpressions.cs	(revision 15017)
@@ -153,5 +153,5 @@
   [PushExpression(StackTypes.IntegerVector, "INTEGER[].FLUSH")]
   [StorableClass]
-  public class IntegerVectorFlushExpression : FlushExpression<List<long>> {
+  public class IntegerVectorFlushExpression : FlushExpression<IReadOnlyList<long>> {
     public IntegerVectorFlushExpression() { }
     [StorableConstructor]
@@ -169,5 +169,5 @@
   [PushExpression(StackTypes.FloatVector, "FLOAT[].FLUSH")]
   [StorableClass]
-  public class FloatVectorFlushExpression : FlushExpression<List<double>> {
+  public class FloatVectorFlushExpression : FlushExpression<IReadOnlyList<double>> {
     public FloatVectorFlushExpression() { }
     [StorableConstructor]
@@ -185,5 +185,5 @@
   [PushExpression(StackTypes.BooleanVector, "BOOLEAN[].FLUSH")]
   [StorableClass]
-  public class BooleanVectorFlushExpression : FlushExpression<List<bool>> {
+  public class BooleanVectorFlushExpression : FlushExpression<IReadOnlyList<bool>> {
     public BooleanVectorFlushExpression() { }
     [StorableConstructor]
@@ -201,5 +201,5 @@
   [PushExpression(StackTypes.StringVector, "STRING[].FLUSH")]
   [StorableClass]
-  public class StringVectorFlushExpression : FlushExpression<List<string>> {
+  public class StringVectorFlushExpression : FlushExpression<IReadOnlyList<string>> {
     public StringVectorFlushExpression() { }
     [StorableConstructor]
